
% author:  Kazantsev Fedor (kazfdr@bionet.nsc.ru)
% copyright LTG ICG SB RAS 2012

% updates: modelsgroup.bionet.nsc.ru
% version: 1.0.0

% that function generates animation of all results at same time

function Frames = movieOfResult( result,frameStep, outRow, outCol,A_templ, Pin1_templ, Pin2_templ, Pin3_templ)

 
% frame counter text parameters
 textX = 5;
 textY = 20;
 
% view parameters
 viewAz = 200;
 viewAng = 35;

% result size
 [rows cols] = size(result);

% the last is for the last dot result
 sliceStep = ceil(rows/frameStep);
 frameSize = sliceStep+1; 
 
 Frames(frameSize) = struct('cdata',[],'colormap',[]);
 currentFrame = 1;
 currentSlice = 1;
 while(currentFrame < frameSize)

   % the result time stamp
   resultSlice = result(currentSlice,:);  
   
   % the sorted result of time stamp
   resultMatrix = sortByTemplate(resultSlice,A_templ,outRow,outCol);      

   subplot(2,2,1); bar3(resultMatrix);
   title('Auxin')   
   view(viewAz,viewAng);   
   
   % print frame number
   text(textX,textY,int2str(currentFrame));
   
   % Another sorted result of time stamp
   resultMatrix = sortByTemplate(resultSlice,Pin1_templ,outRow,outCol);      

   subplot(2,2,2); bar3(resultMatrix);
   title('PIN1')
   view(viewAz,viewAng);
   
   % Another sorted result of time stamp
   resultMatrix = sortByTemplate(resultSlice,Pin2_templ,outRow,outCol);      

   subplot(2,2,3); bar3(resultMatrix);
   title('PIN2')
   view(viewAz,viewAng);
    
   % Another sorted result of time stamp
   resultMatrix = sortByTemplate(resultSlice,Pin3_templ,outRow,outCol);      

   subplot(2,2,4); bar3(resultMatrix);
   title('PIN3')   
   view(viewAz,viewAng);
   

   Frames(currentFrame) = getframe();
   currentFrame = currentFrame+1;
   currentSlice = currentSlice + frameStep;
 end
 
   % decoration of last dot result
   resultSlice = result(rows,:);

   % Aux sorted result
   resultMatrix = sortByTemplate(resultSlice,A_templ,outRow,outCol);      

   subplot(2,2,1); bar3(resultMatrix);
   title('Auxin')
   
   % print text
   text(textX,textY,'Last Dot');   
   view(viewAz,viewAng);
   
   % PIN1 sorted result
   resultMatrix = sortByTemplate(resultSlice,Pin1_templ,outRow,outCol);      

   subplot(2,2,2); bar3(resultMatrix);
   title('PIN1')
   view(viewAz,viewAng);
   
   % PIN2 sorted result
   resultMatrix = sortByTemplate(resultSlice,Pin2_templ,outRow,outCol);      

   subplot(2,2,3); bar3(resultMatrix);
   title('PIN2')
   view(viewAz,viewAng);
   
   % PIN3 sorted result
   resultMatrix = sortByTemplate(resultSlice,Pin3_templ,outRow,outCol);      

   subplot(2,2,4); bar3(resultMatrix);
   title('PIN3')  
   view(viewAz,viewAng);   
   
   Frames(currentFrame) = getframe();
end

