% author:  Kazantsev Fedor (kazfdr@bionet.nsc.ru)
% copyright LTG ICG SB RAS 2012

% updates: modelsgroup.bionet.nsc.ru
% version: 1.0.0

function ret = sortByTemplate( src, templ, rr , cc )

% templ - template of sort. it is the matrix Nx3 where the first is the
% index of variable, the second is the X index to insert (row), the third is Y index to
% insert (column).
% rr - the row size of the output matrix
% cc - the column size of the output matrix
% src - array with values that need to be sort by template  
% templ = 1 1 1
%         2 1 2
%         ...
%         N m k
 ret = zeros(rr,cc); % at the begining they are zeros
 r = size(templ);
 for row = 1:r(1)     
         index = templ(row,1);
         newX = templ(row,2);
         newY = templ(row,3);
         ret(newX,newY) = src(index);    
 end

 % !!!!!!!!!! 
 % root mirror concatenation part

   for row = 1:rr     
	ret(2*rr+1-row,:)=ret(row,:);
   end

 % !!!!!!!!!!
 
end

